//
//definition of MainWindow
//
#ifndef MAINWINDOW_H
#define MAINWINDOW_H
#include<qwidget.h>
#include<qmenubar.h>
#include<qpopupmenu.h>
#include<qapplication.h>
#include<qmessagebox.h>
#include<qfiledialog.h>
#include<qimage.h>
#include"grayscale.h"
#include"to1bit.h"

enum type_filter{
    idGrayScale,
    idTo1bit
};

class MainWindow : public QWidget{
    Q_OBJECT
    
    public:
    MainWindow(QWidget* parent, const char *name);
    
    protected:
    void paintEvent(QPaintEvent*);
    
    private:
    QMenuBar *_menu;
    QPopupMenu *_filemenu;
    QPopupMenu *_helpmenu;
    QPopupMenu *_filtermenu;
    QImage *_buffer;
    GrayScale *_grayscale;
    To1bitDlg *_to1bitDlg;
    To1bit *_to1bit;
    
    private slots:
    void about();
    void aboutQt();
    void slotSave();
    void slotLoad();
    void callFilter(int);
};

#endif //MAINWINDOW_H
